#ifndef ANALYZE_OUT_CPP_
#define ANALYZE_OUT_CPP_
#include "analyze_out.h"


void load_dat(double ****mat_val1, short ****mat_label1,int ***mat_len1, int *nf1,
	int *nq1, int **npos1, char ***names,char *task,int BUFFER_SZ){
	string s,s2,t,t2;int j,q,nf=0,nq=0,le_cntr=0;
	char fname[256];
	bool prev=true;
	ifstream fp;ifstream fp2;
	#ifdef VERBOSE 
		printf("Read sizes and allocate memory\n");fflush(stdout);
	#endif
	for (int i=0;i<135;i++){
		sprintf(fname,"%s/dtls/vals.%s.%d",postfix,task,i);
		fp.open(fname);
		if(fp.is_open()){
			nf++;
			if (prev==false)my_exit("err\n");
			prev=true;
		}else prev=false;
		fp.close();
	}
	
	if(nf==0)my_exit("No data\n");
	sprintf(fname,"%s/dtls/vals.%s.0",postfix,task);
	fp.open(fname);
	while (getline(fp, s, '\n'))nq++;
	fp.close();
	double ***mat_val=new double **[nf];
	short ***mat_label=new short **[nf];
	(*names)=new char*[nq];
	int **mat_len=new int*[nf];
	int *npos=new int[nq];
	
	for (int i=0;i<nf;i++){
		mat_val[i]=new double*[nq];
		mat_label[i]=new short*[nq];
		mat_len[i]=new int[nq];
	}
	string nm;
	#ifdef VERBOSE 
	printf("Reading %d files with %d queries x %d entries\n",nf,nq,BUFFER_SZ);
	#endif
	for (int f=0;f<nf;f++){
		#ifdef VERBOSE 
		printf(".");fflush(stdout);
		#endif
		sprintf(fname,"%s/dtls/label.%s.%d",postfix,task,f);
		fp.open(fname);
		sprintf(fname,"%s/dtls/vals.%s.%d",postfix,task,f);
		fp2.open(fname);
		q=0;j=0;int prev_pos;
		while (getline(fp, s, '\n')) {
			if(f>0)prev_pos=npos[q];npos[q]=0;
			if(!getline(fp2, s2, '\n'))my_exit("Integrity 0\n");
			stringstream line3(s.c_str());
			int last_elements=0,lcntr=0;
			line3 >> t;//name
			if(f==0){(*names)[q]=new char[64];
				strcpy((*names)[q],t.c_str());
			}
			else if(strcmp((*names)[q],t.c_str())!=0){
				printf("Integrity: %s != %s\n",(*names)[q],t.c_str());
				exit(-1);
			}
			while (line3 >> t){if(lcntr>=BUFFER_SZ && atoi(t.c_str())!=0)last_elements++;lcntr++;}//strict inequality because 1st token is name
			if(lcntr<BUFFER_SZ)mat_len[f][q]=lcntr;
			else mat_len[f][q]=BUFFER_SZ+last_elements;
			mat_val[f][q]=new double[mat_len[f][q]];
			mat_label[f][q]=new short[mat_len[f][q]];
			
			//printf("lasr ele=%d\n",last_elements);
			if(last_elements>0)le_cntr++;
			stringstream line(s.c_str());
			stringstream line2(s2.c_str());

			line >> nm;//first token - query name
			line2 >> t2;//first token - query name

			if(strcmp((*names)[q],t2.c_str())!=0){
				printf("Integrity II: %s != %s\n",(*names)[q],t2.c_str());
				exit(-1);
			}
			j=0;while (j<BUFFER_SZ && line >> t) {
				mat_label[f][q][j]=(short)atoi(t.c_str());
				line2 >> t2;
				if(!strcmp(t2.c_str(),"0"))mat_val[f][q][j]=0;
    			else mat_val[f][q][j]=-atof(t2.c_str());
    			if(mat_label[f][q][j]==1)npos[q]++;
    			j++;
    		}

    		while (line >> t) {
    			line2 >> t2;
    			if(atoi(t.c_str())==0)continue;
				mat_label[f][q][j]=(short)atoi(t.c_str());
				if(!strcmp(t2.c_str(),"0"))mat_val[f][q][j]=0;
    			else mat_val[f][q][j]=-atof(t2.c_str());
				if(mat_label[f][q][j]==1)npos[q]++;
				j++;
    		}
    		if( (f>0 && prev_pos!=npos[q]) || (mat_len[f][q]!=j)){
    			printf("Query: %d (%s), file: %d,  prev_pos=%d npos[q]=%d mat_len[f][q]=%d j=%d\n",q,nm.c_str(),f,prev_pos,npos[q],mat_len[f][q],j);
    			my_exit("load_dat:integrity\n");
    		}
    		q++;
		}
		//printf("File pair %d q=%d j=%d\n",f,q,j);
		fp.close();fp2.close();
	}
	(*nf1)=nf;(*nq1)=nq;(*npos1)=npos;(*mat_len1)=mat_len;
	(*mat_val1)=mat_val;(*mat_label1)=mat_label;
}




void load_dat_nt(double ****mat_val1, short ****mat_label1,int ***mat_len1, int *nf1,
	int *nq1, int **npos1, char ***names,char *task,int BUFFER_SZ,int *flist){
	string s,s2,t,t2;int j,q,nf=0,nq=0,le_cntr=0;
	char fname[256];
	bool prev=true;
	ifstream fp;ifstream fp2;
	#ifdef VERBOSE 
		printf("Read sizes and allocate memory\n");fflush(stdout);
	#endif
	for (int i=0;i<135;i++){
		sprintf(fname,"%s/dtls/vals.%s.%d",postfix,task,i);
		fp.open(fname);
		if(fp.is_open()){
			flist[nf++]=i;
		}else prev=false;
		fp.close();
	}
	
	if(nf==0)my_exit("No data\n");
	sprintf(fname,"%s/dtls/vals.%s.%d",postfix,task,flist[0]);
	fp.open(fname);
	while (getline(fp, s, '\n'))nq++;
	fp.close();
	double ***mat_val=new double **[nf];
	short ***mat_label=new short **[nf];
	(*names)=new char*[nq];
	int **mat_len=new int*[nf];
	int *npos=new int[nq];
	
	for (int i=0;i<nf;i++){
		mat_val[i]=new double*[nq];
		mat_label[i]=new short*[nq];
		mat_len[i]=new int[nq];
	}
	string nm;
	#ifdef VERBOSE 
	printf("Reading %d files with %d queries x %d entries\n",nf,nq,BUFFER_SZ);
	#endif
	for (int f=0;f<nf;f++){
		#ifdef VERBOSE 
		printf(".");fflush(stdout);
		#endif
		sprintf(fname,"%s/dtls/label.%s.%d",postfix,task,flist[f]);
		fp.open(fname);
		sprintf(fname,"%s/dtls/vals.%s.%d",postfix,task,flist[f]);
		fp2.open(fname);
		q=0;j=0;int prev_pos;
		while (getline(fp, s, '\n')) {
			if(f>0)prev_pos=npos[q];npos[q]=0;
			if(!getline(fp2, s2, '\n'))my_exit("Integrity 0\n");
			stringstream line3(s.c_str());
			int last_elements=0,lcntr=0;
			line3 >> t;//name
			if(f==0){(*names)[q]=new char[64];
				strcpy((*names)[q],t.c_str());
			}
			else if(strcmp((*names)[q],t.c_str())!=0){
				printf("Integrity: %s != %s\n",(*names)[q],t.c_str());
				exit(-1);
			}
			while (line3 >> t){if(lcntr>=BUFFER_SZ && atoi(t.c_str())!=0)last_elements++;lcntr++;}//strict inequality because 1st token is name
			if(lcntr<BUFFER_SZ)mat_len[f][q]=lcntr;
			else mat_len[f][q]=BUFFER_SZ+last_elements;
			mat_val[f][q]=new double[mat_len[f][q]];
			mat_label[f][q]=new short[mat_len[f][q]];
			
			//printf("lasr ele=%d\n",last_elements);
			if(last_elements>0)le_cntr++;
			stringstream line(s.c_str());
			stringstream line2(s2.c_str());

			line >> nm;//first token - query name
			line2 >> t2;//first token - query name

			if(strcmp((*names)[q],t2.c_str())!=0){
				printf("Integrity II: %s != %s\n",(*names)[q],t2.c_str());
				exit(-1);
			}
			j=0;while (j<BUFFER_SZ && line >> t) {
				mat_label[f][q][j]=(short)atoi(t.c_str());
				line2 >> t2;
				if(!strcmp(t2.c_str(),"0"))mat_val[f][q][j]=0;
    			else mat_val[f][q][j]=-atof(t2.c_str());
    			if(mat_label[f][q][j]==1)npos[q]++;
    			j++;
    		}

    		while (line >> t) {
    			line2 >> t2;
    			if(atoi(t.c_str())==0)continue;
				mat_label[f][q][j]=(short)atoi(t.c_str());
				if(!strcmp(t2.c_str(),"0"))mat_val[f][q][j]=0;
    			else mat_val[f][q][j]=-atof(t2.c_str());
				if(mat_label[f][q][j]==1)npos[q]++;
				j++;
    		}
    		if( (f>0 && prev_pos!=npos[q]) || (mat_len[f][q]!=j)){
    			printf("Query: %d (%s), file: %d,  prev_pos=%d npos[q]=%d mat_len[f][q]=%d j=%d\n",q,nm.c_str(),
					flist[f],prev_pos,npos[q],mat_len[f][q],j);
    			my_exit("load_dat:integrity\n");
    		}
    		q++;
		}
		//printf("File pair %d q=%d j=%d\n",f,q,j);
		fp.close();fp2.close();
	}
	(*nf1)=nf;(*nq1)=nq;(*npos1)=npos;(*mat_len1)=mat_len;
	(*mat_val1)=mat_val;(*mat_label1)=mat_label;
}




void analyze_CV_abs(int fold, char *task,double ***mat_val,short ***mat_label,
	int *npos,char **names,int num_config,int num_samples,int ROC_LIMIT1,int algFlag,int **mat_len){
	//algFlag==1:  1 is good 2 is bad ignore rest and ignore lines with no 2's (HOM)
	char out[256],outw[256],outcv_cls[256];int nneg;
	sprintf(out,"%s/ROC/ROC-%d.%s.abs.%d",postfix,ROC_LIMIT1,task,algFlag);
	sprintf(outcv_cls,"%s/ROC/ROC-%d.%s.abs.%d.cv_cls",postfix,ROC_LIMIT1,task,algFlag);
	sprintf(outw,"%s/ROC/ROC-%d.%s.abs.%d.win",postfix,ROC_LIMIT1,task,algFlag);
	FILE *fpw=fopen(outw,"w");
	int mxlen=-1;
	int *perm_arr=new int[num_samples];
	int *xval_iter_arr=new int[num_samples];
	for(int j=0;j<num_samples;j++){
		perm_arr[j]=j;
		xval_iter_arr[j]=-1;
		for(int s=0;s<num_config;s++)if(mat_len[s][j]>mxlen)mxlen=mat_len[s][j];
	}
	int labels[num_config];
    double scores[num_config];
    double *roc_arr=new double [num_samples*(mxlen)];
    bool *roc_labels=new bool [num_samples*(mxlen)];
	map<int,bool>excluded;
	int *rand_seed=(int *)malloc(sizeof(int));
	//Perm(num_samples,perm_arr,time(NULL)+(int)(*rand_seed));
	for(int y=0;y<num_samples;y++)perm_arr[y]=y;
	free(rand_seed);
	int xval_iter=0,winarr[(int)100/fold + 2];
	double scarr[(int)100/fold + 2];
	#ifdef VERBOSE
	printf("winners: ");
	#endif
	for(int i=0;i<100/fold;i++){
		//printf("Iteration %d \n",xval_iter++);fflush(stdout);
		excluded.clear();
		for(int j=i*num_samples*fold/100;j<(i+1)*num_samples*fold/100 && j<num_samples;j++)
			excluded[perm_arr[j]]=true;
		for(int s=0;s<num_config;s++){
			int k=0;int npos1=0,nneg1=0;
			for(int j=0;j<num_samples;j++){
				if(excluded.find(j)==excluded.end()){
					nneg=0;npos1+=npos[j];
					for(int h=0;h<mat_len[s][j] && nneg<ROC_LIMIT1;h++){
						if(algFlag==0 || algFlag==1&&mat_label[s][j][h]!=0){ //1 or 2
							roc_arr[k]=mat_val[s][j][h];
							roc_labels[k]=mat_label[s][j][h]==1;
							if(!roc_labels[k])nneg++;
							k++;
						}
					}
					nneg1+=nneg;
				}
			}
			scores[s]=roc(roc_arr,roc_labels,k,nneg1,npos1);
			//printf("scores[%d]=%g\n",s,scores[s]);fflush(stdout);
		}
		mergeSort(scores,labels,num_config,false);
		int winner=labels[num_config-1];
		#ifdef VERBOSE 
		printf("%d, ",winner);fflush(stdout);
		#endif
		//printf("winner: %d=%g\n",winner,scores[num_config-1]);fflush(stdout);
		fprintf(fpw,"%d ",winner);
		winarr[xval_iter]=winner;scarr[xval_iter]=scores[num_config-1];
		for(int j=i*num_samples*fold/100;j<(i+1)*num_samples*fold/100 && j<num_samples;j++){
			xval_iter_arr[perm_arr[j]]=xval_iter;
		}xval_iter++;
	}
	#ifdef VERBOSE
	printf("\n");
	#endif
	fclose(fpw);

	FILE *fp_cls=fopen(outcv_cls,"w");
	for(int j=0;j<num_samples;j++){
		fprintf(fp_cls," %s %d\n",names[j],winarr[xval_iter_arr[j]]);
	}fclose(fp_cls);

	double *tot_tp_arr[xval_iter],*tot_fp_arr[xval_iter],
		*tot_prec_arr[xval_iter];
	int len_arr[xval_iter];
	//printf("Calculating output ROC curve\n");
	double nsuc=0,tot_nsuc=0,nsuc2=0,tot_nsuc2=0;
	for(int xid=0;xid<xval_iter;xid++){
		int k=0;int npos1=0,nneg1=0,participating_pos=0;
		int s=winarr[xid];
		for(int j=0;j<num_samples;j++){
			if(xval_iter_arr[j]==-1)my_exit("Problem in Xval\n");
			if(xval_iter_arr[j]!=xid)continue;
			nneg=0;npos1+=npos[j];
			bool first=true;bool has_t=false;bool has_f=false;bool suc2=false;
			for(int h=0;h<mat_len[s][j] && nneg<ROC_LIMIT1;h++){
				if(algFlag==0 || algFlag==1&&mat_label[s][j][h]!=0){
					if(first&&mat_label[s][j][h]==1)suc2=true;first=false;
					has_f|=mat_label[s][j][h]!=1;
					roc_arr[k]=mat_val[s][j][h];
					roc_labels[k]=mat_label[s][j][h]==1;
					if(!roc_labels[k])nneg++;else participating_pos++;
					k++;
				}
			}
			if(npos[j]>0&&has_f){
				tot_nsuc2++;
				if(suc2)nsuc2++;
			}
			if(npos[j]>0){
				tot_nsuc++;
				if(mat_label[s][j][0]==1)nsuc++;
			}
			nneg1+=nneg;
		}
		double *tp_arr,*fp_arr,*prec_arr;int len;
		scarr[xid]=detailed_roc(roc_arr,roc_labels,&tp_arr,&fp_arr,&prec_arr,&len,k,nneg1,npos1);
		if(scarr[xid]==-1){
			printf("Could not compute ROC\n");return;
		}
		tot_tp_arr[xid]=tp_arr;tot_fp_arr[xid]=fp_arr;
		tot_prec_arr[xid]=prec_arr;len_arr[xid]=len;
	}
	printf("Final sucess rates  = %g  and %g\n",nsuc/tot_nsuc,nsuc2/tot_nsuc2);
	double *tp_arr,*fp_arr,*prec_arr,*tp_arr2;
	int len1=average_curve(tot_fp_arr,tot_tp_arr,len_arr,xval_iter,&fp_arr,&tp_arr,100000);
	int len2=average_curve(tot_tp_arr,tot_prec_arr,len_arr,xval_iter,&tp_arr2,&prec_arr,100000);
	printf("Final mROC score = %g std=%g\n",mean(scarr,xval_iter),stdv(scarr,xval_iter));
	FILE *fp=fopen(out,"w");
	int len=len1;if(len<len2)len=len2;
	for(int i=0;i<len;i++){
		if(len1<=i){tp_arr[i]=1;fp_arr[i]=1;}
		if(len2<=i){tp_arr2[i]=1;prec_arr[i]=1;}
		fprintf(fp,"%g %g %g %g\n",tp_arr[i],fp_arr[i],tp_arr2[i],prec_arr[i]);
	}fclose(fp);
	
	delete[]xval_iter_arr;
    delete[]roc_arr;
    delete[]roc_labels;
    delete[]perm_arr;
    
	for(int xid=0;xid<xval_iter;xid++){
    	delete[]tot_tp_arr[xid];
    	delete[]tot_prec_arr[xid];
    	delete[]tot_fp_arr[xid];
    }
	//delete[]tp_arr;delete[]fp_arr;delete[]prec_arr;delete[]tp_arr2;
}


void analyze_CV_rel(int fold, char *task,double ***mat_val,
	short ***mat_label,int *npos,int num_config,int num_samples,
	int ROC_LIMIT1,int algFlag,int **mat_len){
	char out[256],outw[256];int nneg;
	sprintf(out,"%s/ROC/ROC-%d.%s.rel.%d",postfix,ROC_LIMIT1,task,algFlag);
	sprintf(outw,"%s/ROC/ROC-%d.%s.rel.%d.win",postfix,ROC_LIMIT1,task,algFlag);
	FILE *fpw=fopen(outw,"w");
	int labels[num_config];int mxlen=-1;
	double **roc_mat=new double *[num_config];
	for(int s=0;s<num_config;s++){
		labels[s]=s;
		roc_mat[s]=new double[num_samples];
		for(int j=0;j<num_samples;j++)if(mat_len[s][j]>mxlen)mxlen=mat_len[s][j];
	}
	bool is_valid_sample[num_samples];
	int valid_samples=0;
	for(int j=0;j<num_samples;j++){
		nneg=0;
		for(int h=0;h<mat_len[0][j] && nneg<ROC_LIMIT1;h++){
			if(algFlag==0 || algFlag==1&&mat_label[0][j][h]!=0){
				if(mat_label[0][j][h]!=1)nneg++;
				if(nneg>=1)break;
			}
		}
		//is_valid when the top-x is non empty (should not happen)
		is_valid_sample[j]=nneg>=1&&npos[j]>=1;
		if(is_valid_sample[j])valid_samples++;
	}
	#ifdef VERBOSE
	printf("Found %d valid samples out of %d\n",valid_samples,num_samples);
	#endif
	double tmp_roc_arr[mxlen];
	bool tmp_roc_labels[mxlen];
    double scores[num_config];
    for(int s=0;s<num_config;s++){
    	int cntr=0;
    	for(int j=0;j<num_samples;j++){
			if(!is_valid_sample[j])continue;
			nneg=0;int k=0;
			for(int h=0;h<mat_len[s][j] && nneg<ROC_LIMIT1;h++){
				if(algFlag==0 || algFlag==1&&mat_label[s][j][h]!=0){
					tmp_roc_arr[k]=mat_val[s][j][h];
					tmp_roc_labels[k]=mat_label[s][j][h]==1;
					if(!tmp_roc_labels[k])nneg++;
					k++;
				}
			}
			if(k<2){printf("\nSample no.%d file no.%d, len=%d\n",j,s,mat_len[s][j]);
			my_exit("valid_samples: Integrity I\n");}
			roc_mat[s][cntr++]=roc(tmp_roc_arr,tmp_roc_labels,k,nneg,npos[j]);
			//printf("Row %d: ROC with %d sampels, nneg=%d,  npos=%d, ROC=%g\n",j,k,nneg, npos[j],roc_mat[s][cntr-1]);fflush(stdout);
			//for(int kk=0;kk<k;kk++)printf("%g %d\n",tmp_roc_arr[kk],tmp_roc_labels[kk]);my_exit("\n");
		}
	}
	
	int *perm_arr=new int[valid_samples];
	for(int i=0;i<valid_samples;i++)perm_arr[i]=i;
	double *xval_scores=new double[valid_samples];
    for(int j=0;j<valid_samples;j++)xval_scores[j]=-1;
    
	map<int,bool>excluded;
	int *rand_seed=(int *)malloc(sizeof(int));
	Perm(valid_samples,perm_arr,time(NULL)+(int)(*rand_seed));
	free(rand_seed);
	
	for(int i=0;i<100/fold;i++){
		excluded.clear();
		for(int j=i*valid_samples*fold/100;j<(i+1)*valid_samples*fold/100 && j<valid_samples;j++)
			excluded[perm_arr[j]]=true;
		for(int s=0;s<num_config;s++){
			scores[s]=0;
			for(int j=0;j<valid_samples;j++){
				if(excluded.find(j)==excluded.end()){
					scores[s]+=roc_mat[s][j];
				}
			}
		}
		mergeSort(scores,labels,num_config,false);
		int winner=labels[num_config-1];
		fprintf(fpw,"%d ",winner);
		for(int j=i*valid_samples*fold/100;j<(i+1)*valid_samples*fold/100 && j<valid_samples;j++)
			xval_scores[perm_arr[j]]=roc_mat[winner][perm_arr[j]];
	}
	printf("Mean abs ROC score = %g\n",mean(xval_scores,valid_samples));
	fclose(fpw);
	
	FILE *fp=fopen(out,"w");
	for(int i=0;i<valid_samples;i++){
		fprintf(fp,"%g ",xval_scores[i]);
	}fclose(fp);
	
	delete[]xval_scores;
    delete[]perm_arr;
    for(int s=0;s<num_config;s++)delete[]roc_mat[s];
	delete[]roc_mat;
}



void analyze_CV_abs_nt(int fold, char *task,double ***mat_val,short ***mat_label,
	int *npos,char **names,int num_config,int num_samples,int ROC_LIMIT1,
	int algFlag,int **mat_len,int *flist){
	//algFlag==1:  1 is good 2 is bad ignore rest and ignore lines with no 2's (HOM)
	char out[256];int nneg;
	sprintf(out,"%s/ROC/ROC-%d.%s.abs.%d.nt",postfix,ROC_LIMIT1,task,algFlag);
	int mxlen=-1;
	DLS("analyze_CV_abs_nt");
	int *perm_arr=new int[num_samples];
	int *xval_iter_arr=new int[num_samples];
	for(int j=0;j<num_samples;j++){
		perm_arr[j]=j;
		xval_iter_arr[j]=-1;
		for(int s=0;s<num_config;s++)if(mat_len[s][j]>mxlen)mxlen=mat_len[s][j];
	}
	int labels[num_config];
    double scores[num_config];
    double *roc_arr=new double [num_samples*(mxlen)];
    bool *roc_labels=new bool [num_samples*(mxlen)];
	
	////////////////////////////////////
	nlist3 qlist;
	for(int j=0;j<num_samples;j++){qlist[names[j]]=j;}
	char fH[MAX_SPEC][NAME_LEN],fC[MAX_SPEC][NAME_LEN],Qfile[NAME_LEN],
  		GSCfile[NAME_LEN],GSHfile[NAME_LEN],fname[NAME_LEN],name1[64],name2[64];
	int sH[MAX_SPEC][2],sC[MAX_SPEC][2],nH,nC,val;
	sprintf(fname,"%s/../config",postfix);
	load_config(fname,fH,&nH,sH,fC,&nC,sC,Qfile,GSCfile,GSHfile);
	sprintf(fname,"%s.nt",GSHfile);
	//sprintf(fname,"/home/medcns2/home/niryosef/Kchore/Hom-bench/dat/nodes.hg.dat");
	FILE *fp_nt=fopen(fname,"r");
	nlist2 NTQ;
	while(fscanf(fp_nt,"%s\t%s\t%d\n",name1,name2,&val)!=EOF){
	  	nlist3::iterator ii1=qlist.find(name1);
		if(ii1==qlist.end())continue;
		NTQ[ii1->second]=-1;
	}fclose(fp_nt);
	printf("Limiting to %d queries\n",NTQ.size());FLS;
	sprintf(fname,"%s/ROC/ROC-%d.%s.abs.%d.cv_cls",postfix,ROC_LIMIT1,task,algFlag);
	fp_nt=fopen(fname,"r");
	int conf_id;
	Present confs;
	while(fscanf(fp_nt,"%s\t%d\n",name1,&conf_id)!=EOF){
	  	nlist3::iterator ii1=qlist.find(name1);
		if(ii1==qlist.end())continue;
		if(NTQ.find(ii1->second)==NTQ.end())continue;
		NTQ[ii1->second]=conf_id;
		confs[conf_id]=true;
	}fclose(fp_nt);
	int xval_iter=0,winarr[(int)100/fold + 2];
	double scarr[(int)100/fold + 2];
	for(Present::iterator ii=confs.begin();ii!=confs.end();ii++)
	{winarr[xval_iter++]=ii->first;}
	////////////////////////////////////
	
	double *tot_tp_arr[xval_iter],*tot_fp_arr[xval_iter],
		*tot_prec_arr[xval_iter];
	int len_arr[xval_iter],xid1=0;
	//printf("Calculating output ROC curve\n");
	double nsuc=0,tot_nsuc=0,nsuc2=0,tot_nsuc2=0;
	for(int xid=0;xid<xval_iter;xid++){
		int k=0;int npos1=0,nneg1=0,participating_pos=0;
		int s=ismember(winarr[xid],flist,num_config);
		for(int j=0;j<num_samples;j++){
			if(NTQ.find(j)==NTQ.end())continue;
			if(NTQ[j]==-1)my_exit("Problem in Xval\n");
			if(NTQ[j]!=winarr[xid])continue;
			nneg=0;npos1+=npos[j];
			bool first=true;bool has_t=false;bool has_f=false;bool suc2=false;
			for(int h=0;h<mat_len[s][j] && nneg<ROC_LIMIT1;h++){
				if(algFlag==0 || algFlag==1&&mat_label[s][j][h]!=0){
					if(first&&mat_label[s][j][h]==1)suc2=true;first=false;
					has_f|=mat_label[s][j][h]!=1;
					roc_arr[k]=mat_val[s][j][h];
					roc_labels[k]=mat_label[s][j][h]==1;
					if(!roc_labels[k])nneg++;else participating_pos++;
					k++;
				}
			}
			if(npos[j]>0&&has_f){
				tot_nsuc2++;
				if(suc2)nsuc2++;
			}
			if(npos[j]>0){
				tot_nsuc++;
				if(mat_label[s][j][0]==1)nsuc++;
			}
			nneg1+=nneg;
		}
		if(npos1>0){
			double *tp_arr,*fp_arr,*prec_arr;int len;
			scarr[xid1]=detailed_roc(roc_arr,roc_labels,&tp_arr,&fp_arr,&prec_arr,&len,k,nneg1,npos1);
			if(scarr[xid1]==-1){
				printf("Could not compute ROC\n");return;
			}
			tot_tp_arr[xid1]=tp_arr;tot_fp_arr[xid1]=fp_arr;
			tot_prec_arr[xid1]=prec_arr;len_arr[xid1]=len;
			xid1++;
		}
	}
	printf("Combining %d curves\n",xid1);
	printf("Final sucess rates  = %g  and %g\n",nsuc/tot_nsuc,nsuc2/tot_nsuc2);
	double *tp_arr,*fp_arr,*prec_arr,*tp_arr2;
	int len1=average_curve(tot_fp_arr,tot_tp_arr,len_arr,xid1,&fp_arr,&tp_arr,100000);
	int len2=average_curve(tot_tp_arr,tot_prec_arr,len_arr,xid1,&tp_arr2,&prec_arr,100000);
	printf("Final mROC score = %g std=%g\n",mean(scarr,xid1),stdv(scarr,xid1));
	FILE *fp=fopen(out,"w");
	int len=len1;if(len<len2)len=len2;
	for(int i=0;i<len;i++){
		if(len1<=i){tp_arr[i]=1;fp_arr[i]=1;}
		if(len2<=i){tp_arr2[i]=1;prec_arr[i]=1;}
		fprintf(fp,"%g %g %g %g\n",tp_arr[i],fp_arr[i],tp_arr2[i],prec_arr[i]);
	}fclose(fp);
	
	delete[]xval_iter_arr;
    delete[]roc_arr;
    delete[]roc_labels;
    delete[]perm_arr;
    
	for(int xid=0;xid<xid1;xid++){
    	delete[]tot_tp_arr[xid];
    	delete[]tot_prec_arr[xid];
    	delete[]tot_fp_arr[xid];
    }
	//delete[]tp_arr;delete[]fp_arr;delete[]prec_arr;delete[]tp_arr2;
}


void analyze_CV_rel_nt(int fold, char *task,double ***mat_val,
	short ***mat_label,int *npos,char **names,int num_config,int num_samples,
	int ROC_LIMIT1,int algFlag,int **mat_len){
	char out[256];int nneg;
	sprintf(out,"%s/ROC/ROC-%d.%s.rel.%d.nt",postfix,ROC_LIMIT1,task,algFlag);
	int labels[num_config];int mxlen=-1;
	double **roc_mat=new double *[num_config];
	for(int s=0;s<num_config;s++){
		labels[s]=s;
		roc_mat[s]=new double[num_samples];
		for(int j=0;j<num_samples;j++)if(mat_len[s][j]>mxlen)mxlen=mat_len[s][j];
	}
	bool is_valid_sample[num_samples];
	int valid_samples=0;
	for(int j=0;j<num_samples;j++){
		nneg=0;
		for(int h=0;h<mat_len[0][j] && nneg<ROC_LIMIT1;h++){
			if(algFlag==0 || algFlag==1&&mat_label[0][j][h]!=0){
				if(mat_label[0][j][h]!=1)nneg++;
				if(nneg>=1)break;
			}
		}
		//is_valid when the top-x is non empty (should not happen)
		is_valid_sample[j]=nneg>=1&&npos[j]>=1;
		if(is_valid_sample[j])valid_samples++;
	}
	#ifdef VERBOSE
	printf("Found %d valid samples out of %d\n",valid_samples,num_samples);
	#endif
	double tmp_roc_arr[mxlen];
	bool tmp_roc_labels[mxlen];
    double scores[num_config];
	nlist3 qlist;
    for(int s=0;s<num_config;s++){
    	int cntr=0;
    	for(int j=0;j<num_samples;j++){
			if(!is_valid_sample[j])continue;
			nneg=0;int k=0;
			for(int h=0;h<mat_len[s][j] && nneg<ROC_LIMIT1;h++){
				if(algFlag==0 || algFlag==1&&mat_label[s][j][h]!=0){
					tmp_roc_arr[k]=mat_val[s][j][h];
					tmp_roc_labels[k]=mat_label[s][j][h]==1;
					if(!tmp_roc_labels[k])nneg++;
					k++;
				}
			}
			if(k<2){printf("\nSample no.%d file no.%d, len=%d\n",j,s,mat_len[s][j]);
			my_exit("valid_samples: Integrity I\n");}
			roc_mat[s][cntr++]=roc(tmp_roc_arr,tmp_roc_labels,k,nneg,npos[j]);
			//printf("Row %d: ROC with %d sampels, nneg=%d,  npos=%d, ROC=%g\n",j,k,nneg, npos[j],roc_mat[s][cntr-1]);fflush(stdout);
			//for(int kk=0;kk<k;kk++)printf("%g %d\n",tmp_roc_arr[kk],tmp_roc_labels[kk]);my_exit("\n");
		}
	}
	
	int cntr=0;
    for(int j=0;j<num_samples;j++)
		if(is_valid_sample[j])qlist[names[j]]=cntr++;

	char fH[MAX_SPEC][NAME_LEN],fC[MAX_SPEC][NAME_LEN],Qfile[NAME_LEN],
  		GSCfile[NAME_LEN],GSHfile[NAME_LEN],fname[NAME_LEN],name1[64],name2[64];
	int sH[MAX_SPEC][2],sC[MAX_SPEC][2],nH,nC,val;
	sprintf(fname,"%s/../config",postfix);
	load_config(fname,fH,&nH,sH,fC,&nC,sC,Qfile,GSCfile,GSHfile);
	sprintf(fname,"%s.nt",GSHfile);
	//sprintf(fname,"/home/medcns2/home/niryosef/Kchore/Hom-bench/dat/nodes.hg.dat");
	FILE *fp_nt=fopen(fname,"r");
	Present NTQ;
	while(fscanf(fp_nt,"%s\t%s\t%d\n",name1,name2,&val)!=EOF){//Qmap.size()<100 && 
	  	nlist3::iterator ii1=qlist.find(name1);
		if(ii1==qlist.end()){
			continue;
		}
		//DLS(name1);
		NTQ[ii1->second]=true;
	}
	printf("Limiting to %d queries\n",NTQ.size());


	int *perm_arr=new int[valid_samples];
	for(int i=0;i<valid_samples;i++)perm_arr[i]=i;
	double *xval_scores=new double[valid_samples];
    for(int j=0;j<valid_samples;j++)xval_scores[j]=-1;
    
	map<int,bool>excluded;
	int *rand_seed=(int *)malloc(sizeof(int));
	Perm(valid_samples,perm_arr,time(NULL)+(int)(*rand_seed));
	free(rand_seed);
	
	for(int i=0;i<100/fold;i++){
		excluded.clear();
		for(int j=i*valid_samples*fold/100;j<(i+1)*valid_samples*fold/100 && j<valid_samples;j++)
			excluded[perm_arr[j]]=true;
		for(int s=0;s<num_config;s++){
			scores[s]=0;
			for(int j=0;j<valid_samples;j++){
				if(excluded.find(j)==excluded.end()){
					scores[s]+=roc_mat[s][j];
				}
			}
		}
		mergeSort(scores,labels,num_config,false);
		int winner=labels[num_config-1];
		for(int j=i*valid_samples*fold/100;j<(i+1)*valid_samples*fold/100 && j<valid_samples;j++)
			xval_scores[perm_arr[j]]=roc_mat[winner][perm_arr[j]];
	}
	printf("Mean abs ROC score = %g\n",mean(xval_scores,valid_samples));
	
	
	FILE *fp=fopen(out,"w");
	for(int i=0;i<valid_samples;i++){
		if(NTQ.find(i)!=NTQ.end())
			fprintf(fp,"%g ",xval_scores[i]);
	}fclose(fp);
	
	delete[]xval_scores;
    delete[]perm_arr;
    for(int s=0;s<num_config;s++)delete[]roc_mat[s];
	delete[]roc_mat;
}


#endif /*ANALYZE_OUT_CPP_*/

