#ifndef ANALYZE_Q_CPP_
#define ANALYZE_Q_CPP_
#include "analyze_q.h"

void analyze_q(int ind){
	#ifdef VERBOSE
	printf("analyze_q\n");fflush(stdout);
	#endif
	if(Qalg_FLAG==0){ 
		#ifdef VERBOSE 
		printf("mk NBLAST input\n");
		#endif
		if(dataset==MRF)rank_q(ind);
		else{
			double *l_hood,*ths;
			int len=calc_prob(&l_hood,&ths); 
			rank_q(l_hood,ths,len);
			delete[] l_hood;
		}
		return;
	}
	if(Qalg_FLAG>0){
		#ifdef VERBOSE
		printf("Mk global top lists\n");
		#endif
		//Create a copy with collapsed Q
		double **matrix1;bool **isHom1;
		int **matrixind1,**matrixind_out1,*degOutarr=new int[dim+1],
			*degarr=new int[dim+1],*degCarr=new int[dim+1];
		collapse_Q(&matrix1,&matrixind1,&matrixind_out1,&isHom1,degarr,degOutarr,degCarr);
		cand_list_q(0);
		//Redirect pointers and re-run
		clean_grph();
		matrix=matrix1;matrixind=matrixind1;isHom=isHom1;matrixind_out=matrixind_out1;
		Qmap.clear();Qmap[dim]=true;dim++;
		for(int i=0;i<dim;i++){nodeList[i]->deg=degarr[i];
			nodeList[i]->degC=degCarr[i];
			nodeList[i]->degOut=degOutarr[i];
		}delete[] degarr;delete[] degOutarr;delete[] degCarr;
		if(NRM_METHOD==1)normalize(Tmatrix,OPT2!=1&&OPT2!=8,-1,-1);
		cand_list_q(1);
		return;
	}
	printf("Warning: Unknown QFLAG\n");
}

void collapse_Q(double ***matrix1, int ***matrixind1, int ***matrixind_out1, bool ***isHom1, int *degarr, int *degOutarr,int *degCarr){
	double **matrix2=new double*[dim+1];
	int **matrixind2=new int*[dim+1];
	int **matrixind_out2=new int*[dim+1];
	bool **isHom2=new bool*[dim+1];
	int spec=nodeList[Qmap.begin()->first]->spec;
	double *Qweights=new double[dim];
	int i,j;
	bool *has_out_edge_from_Q=new bool[dim];
	for(i=0;i<dim;i++){has_out_edge_from_Q[i]=false;Qweights[i]=0;}
	for(i=0;i<dim;i++){
		if(Qmap.find(i)!=Qmap.end()){
			for(j=0;j<nodeList[i]->deg;j++){
				if(Qmap.find(matrixind[i][j])==Qmap.end()){
					if(isHom[i][j])Qweights[matrixind[i][j]]+=tf2(matrix[i][j],sigmaH*MAXh);
					else Qweights[matrixind[i][j]]+=tf2(matrix[i][j],sigmaC*MAXc);
				}
			}
			degCarr[i]=0;
			degarr[i]=0;
			degOutarr[i]=0;
		}
		else{
			int k=0;double w=0;int kC=0;
			matrix2[i]=new double[nodeList[i]->deg+1];
			matrixind2[i]=new int[nodeList[i]->deg+1];
			matrixind_out2[i]=new int[nodeList[i]->degOut+1];
			isHom2[i]=new bool[nodeList[i]->deg+1];
			for(j=0;j<nodeList[i]->deg;j++){
				if(Qmap.find(matrixind[i][j])!=Qmap.end()){
					if(isHom[i][j])w+=tf2(matrix[i][j],sigmaH*MAXh);
					else w+=tf2(matrix[i][j],sigmaC*MAXc);
				}else{
					matrix2[i][k]=matrix[i][j];	
					matrixind2[i][k]=matrixind[i][j];
					isHom2[i][k++]=isHom[i][j];
					if(!isHom[i][j])kC++;
				}
			}
			has_out_edge_from_Q[i]=w>0;
			if(has_out_edge_from_Q[i]){
				isHom2[i][k]=nodeList[i]->spec!=spec;
				if(isHom2[i][k])matrix2[i][k]=tf2_comp(w,sigmaH*MAXh);
				else matrix2[i][k]=tf2_comp(w,sigmaC*MAXc);
				if(matrix2[i][k]<TINY)matrix2[i][k]=TINY;
				matrixind2[i][k]=dim;
				if(!isHom2[i][k])kC++;
				k++;
			}
			degCarr[i]=kC;
			degarr[i]=k;
			k=0;
			bool has_out_edge_2_Q=false;
			for(j=0;j<nodeList[i]->degOut;j++){
				if(Qmap.find(matrixind_out[i][j])!=Qmap.end()){
					has_out_edge_2_Q=true;
				}else{
					matrixind_out2[i][k++]=matrixind_out[i][j];
				}
			}
			if(has_out_edge_2_Q){
				matrixind_out2[i][k++]=dim;
			}
			degOutarr[i]=k;
		}
	} 
	int k=0,kout=0;char *nm=new char[32];sprintf(nm,"Qset");
	for(i=0;i<dim;i++){
		if(Qweights[i]>0)k++;
		if(has_out_edge_from_Q[i])kout++;
	}
	node *nd=new node(spec,k,nm);if(nd->id!=dim){
		my_exit("Integrity\n");
	}
	#ifdef VERBOSE
	printf("In/out Degree of shrinked node is %d %d\n",k,kout);fflush(stdout);
	#endif
	degarr[dim]=k;
	degOutarr[dim]=kout;
	matrix2[dim]=new double[k];
	matrixind2[dim]=new int[k];
	matrixind_out2[dim]=new int[kout];
	nodeList[dim]=nd;
	Tmatrix[dim]=new double[k];
	isHom2[dim]=new bool[k];
	k=0;kout=0;int kC=0;
	for(i=0;i<dim;i++){
		if(Qweights[i]>0){
		isHom2[dim][k]=nodeList[i]->spec!=spec;
		if(isHom2[dim][k])matrix2[dim][k]=tf2_comp(Qweights[i],sigmaH*MAXh);
		else {matrix2[dim][k]=tf2_comp(Qweights[i],sigmaC*MAXc);kC++;}
		if(matrix2[dim][k]<TINY)matrix2[dim][k]=TINY;
		matrixind2[dim][k++]=i;
	   }
	   if(has_out_edge_from_Q[i])matrixind_out2[dim][kout++]=i;
	}
	#ifdef VERBOSE
	printf("PPI Degree of shrinked node is %d\n",kC);fflush(stdout);
	#endif
	degCarr[dim]=kC;
	delete[]has_out_edge_from_Q;
	*matrix1=matrix2;*matrixind1=matrixind2;*isHom1=isHom2;
	*matrixind_out1=matrixind_out2;
}

void cand_list_q(int method){
	#ifdef VERBOSE
	printf("cand_list_q:%d\n", method);fflush(stdout);
	#endif
	double **rank,**rank_sig,*median_sig;int labels[dim];
	node *nd;
	calc_emp_pval(&rank,&rank_sig,&median_sig,false);
	char fname[NAME_LEN];
	if(method==0)sprintf(fname,"%s/top_mean_rank",postfix);
	else sprintf(fname,"%s/top_combined_rank",postfix);
  	FILE *fp=fopen(fname,"w");if(fp==NULL)my_exit("IO error 3\n");
  	double mean_tmp[dim];
  	int k=0;for(int i=0;i<dim;i++)if(median_sig[i]!=99)mean_tmp[k++]=median_sig[i];
  	double th=FDR(mean_tmp,k,0,0.05);
  	mergeSort(median_sig,labels,dim,false);
  	int num_written=0,num_sig=0;
  	#ifdef VERBOSE 
  	printf("min=%g, th=%g\n",median_sig[0],th);
  	#endif
  	int qcntr=0,qxref[Qmap.size()];
  	for(map<int,bool>::iterator kk=Qmap.begin();kk!=Qmap.end();kk++) 
		qxref[qcntr++]=kk->first;
  	int best_ind[dim];
  	for(int i=0;i<dim;i++){
  		double tmparr[Qmap.size()],tmparr2[Qmap.size()];
  		for(int q=0;q<Qmap.size();q++)tmparr[q]=rank_sig[q][i];
  		double tmp=get_min(tmparr,Qmap.size());
  		if(tmp>=1){best_ind[i]=-1;continue;}
  		char tmpstr1[32],tmpstr2[32];
  		sprintf(tmpstr1,"%g",tmp);
  		for(int q=0;q<Qmap.size();q++){
  			sprintf(tmpstr2,"%g",tmparr[q]);
  			if(!strcmp(tmpstr1,tmpstr2)){tmparr2[q]=rank[q][i];}
  			else tmparr2[q]=-999999;
  		}
  		tmp=get_max(tmparr2,Qmap.size(),&(best_ind[i]));
  		if(tmp==-999999 || (!(OPT2==0 || OPT2==6 || OPT2==7)&&tmp==0))
  		{best_ind[i]=-1;continue;}
  		best_ind[i]=qxref[best_ind[i]];
  	}
  	char tmpstr[64];
  	for(int i=0;i<dim&& num_written<Qalg_FLAG && median_sig[i]!=99;i++){
	  nd=nodeList[labels[i]];
	  if(best_ind[labels[i]]!=-1)sprintf(tmpstr,"%s",nodeList[best_ind[labels[i]]]->name);
	  else sprintf(tmpstr,"--");
	  fprintf(fp,"%s\t%g\t%d\t%s\n",
	  	nd->name,median_sig[i],median_sig[i]<=th,tmpstr);
	  //fprintf(fp,"%s\t%g\t%g\t%d\n",nd->name,grp_score[labels[i]],median_sig[i],median_sig[i]<=th);
	   num_written++;if(median_sig[i]<=th)num_sig++;
	}fclose(fp);  
	printf("Wrote %d significant candidates\n",num_sig);
	for(int q=0;q<Qmap.size();q++){
		delete[]rank_sig[q];delete[]rank[q];
	}
	delete[] rank_sig;delete[] median_sig;delete[]rank;
	
} 

	
void rank_q(int ind){
	int NUM_TO_WRITE=50;
	char fname[NAME_LEN];
	int labels[dim];
	if(ind==-1)
		sprintf(fname,"%s/query-all.sig.res",postfix);
	else
		sprintf(fname,"%s/query.tmpsig%d.res",postfix,ind);
  	FILE *fp=fopen(fname,"w");if(fp==NULL)my_exit("IO error 4\n");
  	if(ind==-1)
		sprintf(fname,"%s/query-all.rank.res",postfix);
	else
		sprintf(fname,"%s/query.tmprank%d.res",postfix,ind);
  	FILE *fp2=fopen(fname,"w");if(fp==NULL)my_exit("IO error 5\n");
  	double **rank_sig,**rank,*median_sig;
	calc_emp_pval(&rank,&rank_sig,&median_sig,true);
	int qnum=0;double *y=new double[dim];
	for(map<int,bool>::iterator kk=Qmap.begin();kk!=Qmap.end();kk++){
		memcpy(y,rank_sig[qnum],sizeof(double)*dim);
		int i=0,num_written=0; 
		node *nd,*cur_nd=nodeList[kk->first];
		if(false && OPT2!=11){
			mergeSort(y,labels,dim);
			while(i<dim&& num_written<NUM_TO_WRITE){
				nd=nodeList[labels[i]];
				if(nd->id==kk->first || nd->spec==cur_nd->spec){i++;continue;}
				if(get_abs(y[i])>=1)break;
				if(ind==-1)
					fprintf(fp,"%s\t%s\t%g\t%g\n",cur_nd->name,nd->name,rank[qnum][labels[i]],y[i]);
				else
					fprintf(fp,"%s\t%s\t%g\t%g\t%d\n",cur_nd->name,nd->name,rank[qnum][labels[i]],y[i],ind);
				if(cur_nd->GSH.find(nd)!=cur_nd->GSH.end())cur_nd->GSH[nd]=1;
				num_written++;i++;
			}
			for(nlist::iterator jj=cur_nd->GSH.begin();jj!=cur_nd->GSH.end();jj++){
			if(jj->second==0)
				if(ind==-1)
					fprintf(fp,"%s\t%s\t%g\t%g\n",
						cur_nd->name,jj->first->name,rank[qnum][jj->first->id],rank_sig[qnum][jj->first->id]);
				else
					fprintf(fp,"%s\t%s\t%g\t%g\t%d\n",
						cur_nd->name,jj->first->name,rank[qnum][jj->first->id],
						rank_sig[qnum][jj->first->id],ind);
			jj->second=0;
		}
		}
		bool incl=num_written>0;
		
		memcpy(y,rank[qnum],sizeof(double)*dim);
		mergeSort(y,labels,dim);
		i=1,num_written=0; 
		while(i<=dim&&num_written<NUM_TO_WRITE){
			nd=nodeList[labels[dim-i]];
			if(OPT2!=6 && y[dim-i]<=0 || OPT2==6&&y[dim-i]==-999999)break;
			if(nd->id==kk->first || rank_sig[qnum][labels[dim-i]]==99 || nd->spec==cur_nd->spec){i++;continue;}
			if(ind==-1)
				fprintf(fp2,"%s\t%s\t%g\t%g\n",cur_nd->name,nd->name,y[dim-i],rank_sig[qnum][labels[dim-i]]);
			else
				fprintf(fp2,"%s\t%s\t%g\t%g\t%d\n",cur_nd->name,nd->name,y[dim-i],rank_sig[qnum][labels[dim-i]],ind);
			if(cur_nd->GSH.find(nd)!=cur_nd->GSH.end())cur_nd->GSH[nd]=1;
			num_written++;i++;
		}
		for(nlist::iterator jj=cur_nd->GSH.begin();jj!=cur_nd->GSH.end();jj++){
				/*if(jj->second==0)
				if(ind==-1)
					fprintf(fp2,"%s\t%s\t%g\t%g\n",
						cur_nd->name,jj->first->name,rank[qnum][jj->first->id],rank_sig[qnum][jj->first->id]);
				else
					fprintf(fp2,"%s\t%s\t%g\t%g\t%d\n",
						cur_nd->name,jj->first->name,rank[qnum][jj->first->id],rank_sig[qnum][jj->first->id],ind);
				*/
		}	
		//if(!incl || num_written==0)
		//	printf("Query %s not included\n",nodeList[kk->first]->name);
		qnum++;
	 }
	for(int q=0;q<qnum;q++){
		delete[]rank_sig[q];delete[]rank[q];
	}
	delete[] rank_sig;delete[] median_sig;delete[]rank;delete[]y;
	fclose(fp);fclose(fp2);
} 
void rank_q(double *l_hood,double *ths,int l_hood_len){
	char fname[NAME_LEN];
	int labels[dim];
	sprintf(fname,"%s/q_lhood_10",postfix);
  	FILE *fp=fopen(fname,"w");if(fp==NULL)my_exit("IO error 6\n");
  	sprintf(fname,"%s/q_lhood_500",postfix);
  	FILE *fp2=fopen(fname,"w");if(fp==NULL)my_exit("IO error 7\n");
	double **rank_sig,**rank,*median_sig;
	calc_emp_pval(&rank,&rank_sig,&median_sig,true);
	int qnum=0;
	for(map<int,bool>::iterator kk=Qmap.begin();kk!=Qmap.end();kk++){
		mergeSort(rank_sig[qnum],labels,dim);
	 	out_lhood(kk->first,rank_sig[qnum],labels,l_hood,ths,l_hood_len,fp,fp2);
	 	qnum++;
	 }
	 for(int q=0;q<qnum;q++){
		delete[]rank_sig[q];delete[]rank[q];
	}
	delete[] rank_sig;delete[] median_sig;delete[]rank;
	fclose(fp);fclose(fp2);
} 
	
void out_lhood(int k,double *y,int *labels, double *l_hood, double *ths, int l_hood_len, FILE *fp, FILE *fp2){
	int i=0,num_written=0; 
	node *nd;
	while(i<dim&& num_written<100){
	    nd=nodeList[labels[i]];
	    if(nd->id==k){i++;continue;}
	    if(y[i]==99)break;
	    int kk=0;while(kk<l_hood_len){if(y[i]<=ths[kk])break;kk++;}
	    if(kk==l_hood_len-1)break;
	    if(num_written<10)
	    	fprintf(fp,"%s\t%s\t%g\t%g\t%d\n",nodeList[k]->name,nodeList[labels[i]]->name,l_hood[kk],y[i],kk);
	    fprintf(fp2,"%s\t%s\t%g\t%g\t%d\n",nodeList[k]->name,nodeList[labels[i]]->name,l_hood[kk],y[i],kk);
	    num_written++;i++;
	}
	if(num_written==0)printf("Query %s not included, best is %g\n",nodeList[k]->name,y[i]);
}
 

int calc_prob(double **l_hood1,double **ths1){
	string s,t,s2,t2;int cntr=0,cntr_t=0;
	char fname[256];
	FILE *fp;
	#ifdef VERBOSE 
	printf("Calculate P(val) and P(val | H)\n");fflush(stdout);
	#endif
	sprintf(fname,"%s/emp_dist",postfix);
	fp=fopen(fname,"r");
	float w;int lab;
	while(fscanf(fp,"%f %d",&w ,&lab)!=EOF){
		cntr++;if(lab==1)cntr_t++;
	}
	double *arr_all=new double[cntr];
	double *arr_t=new double[cntr_t];
	rewind(fp);cntr=0;cntr_t=0;
	while(fscanf(fp,"%f %d",&w, &lab)!=EOF){
		arr_all[cntr++]=w;
		if(lab==1)arr_t[cntr_t++]=w;
	}
	#ifdef VERBOSE
	printf("Read %d samples, %d of which are positive\n",cntr,cntr_t);
	#endif
	mergeSort(arr_all,cntr);
	mergeSort(arr_t,cntr_t);
	int n_bin=500;
	double *ths=new double [n_bin];
	/*double step=(arr_all[cntr-1]-arr_all[0])/(double)n_bin;
	printf("MAx: %g, min:%g, step=%g\n",arr_all[cntr-1],arr_all[0],step);
	for(int i=0;i<n_bin;i++)ths[i]=step*(double)(i+1) + arr_all[0];
	ths[n_bin-1]+=1e-5;//rase the max - avoid floating point accuracy issues
	*/
	double mn=arr_all[0];if(mn<TINY)mn=TINY;
	double mx=arr_all[cntr-1];
	double step=(log(mx)-log(mn))/(double)n_bin;
	#ifdef VERBOSE
	printf("MAx: %g, min:%g, step=%g\n",mx,mn,step);
	#endif
	for(int i=0;i<n_bin;i++)ths[i]=exp(step*(double)(i+1) + log(mn));
	ths[n_bin-1]+=1e-5;//rase the upper bound - avoid floating point comparison issues
	#ifdef VERBOSE
	printf("Computing histograms\n");fflush(stdout);
	#endif
	double *P_val=hist(arr_all,cntr,ths,n_bin);
	double *P_val_H=hist(arr_t,cntr_t,ths,n_bin);
	double *Freq_P_val=new double[n_bin];
	double *Freq_P_val_H=new double[n_bin];
	for(int i=0;i<n_bin;i++){
		Freq_P_val[i]=P_val[i];
		//P_val[i]=-P_val[i];
		Freq_P_val_H[i]=P_val_H[i];
		//P_val_H[i]=-P_val_H[i];
	}
	//printf("Pool adjacent violators\n");fflush(stdout);
	//pav(P_val,n_bin);  
	//pav(P_val_H,n_bin);
	//for(int i=0;i<n_bin;i++){
		//P_val[i]=-P_val[i];
		//P_val_H[i]=-P_val_H[i];
	//}
	for(int i=1;i<n_bin;i++){
		P_val[i]+=P_val[i-1];
		P_val_H[i]+=P_val_H[i-1];
	}
	for(int i=0;i<n_bin;i++){
		P_val[i]/=P_val[n_bin-1];
		P_val_H[i]/P_val_H[n_bin-1];
	}
	
	int s1=-1,cntr1=0,cntr2=0;
	for(int i=0;i<dim;i++){ 
		if(s1==-1)s1=nodeList[i]->spec;
		if(nodeList[i]->spec==s1)cntr1++;
		else cntr2++;
	}
	double p_H=(double)cntr_t/(cntr1*cntr2);
	#ifdef VERBOSE 
	printf("Calculate P(H)=%g \n",p_H);
	printf("Calculate P(H | val)\n");
	#endif
	
	double *P_H_val=new double[n_bin];
	for(int i=0;i<n_bin;i++){
		P_H_val[i]=P_val_H[i]*p_H/P_val[i];
	}
	#ifdef VERBOSE 
	printf("Calculate P_rand\n");
	#endif
	double P_rnd=0;
	for(int i=0;i<n_bin;i++){
		P_rnd+=P_H_val[i]*Freq_P_val[i];
	}
	#ifdef VERBOSE 
	printf("Calculate log likelihood\n");
	#endif
	double *l_hood=new double[n_bin];
	for(int i=0;i<n_bin;i++){
		l_hood[i]=log(P_H_val[i]/P_rnd);
	}
	
	sprintf(fname,"%s/lscore.stat",postfix);
	FILE *fp11=fopen(fname,"w");
	for(int i=0;i<n_bin;i++)
		fprintf(fp11,"%g %g %g %g %g %g %g %g\n",ths[i],P_val[i],P_val_H[i],P_H_val[i],
			l_hood[i],P_rnd,Freq_P_val[i],Freq_P_val_H[i]);
	fclose(fp11);
	(*ths1)=ths;(*l_hood1)=l_hood;
	delete[] arr_t;delete[] arr_all;delete[] Freq_P_val;delete[]Freq_P_val_H;
	delete[] P_val;delete[] P_val_H;delete[] P_H_val;delete[] P_val_H;
	return n_bin;
}

void shuffle(double swap_fact,bool shuffle_in_Q){
  //printf("Shuffle\n");fflush(stdout);
  int rnd1,rnd2,rnd_loc1,rnd_loc2,deg1,deg2,cntr=0;
  node *src1,*src2,*trg1,*trg2;
  map <int ,bool>visited;
  for(int i=0;i<((int)dim*swap_fact);i++){
  	bool homFlag=my_drand48()>0.5;
	src1=nodeList[(int)(my_drand48()*(double)dim)];
	if(homFlag)deg1=src1->deg-src1->degC;else deg1=src1->degC;
	if(deg1==0)continue;
	src2=nodeList[(int)(my_drand48()*(double)dim)];
	if(src1==src2 || src1->spec!=src2->spec)continue;
	if(homFlag)deg2=src2->deg-src2->degC;else deg2=src2->degC;
	if(deg2==0)continue;
	rnd1=(int)(my_drand48()*(double)deg1);
	bool found=false;int k=0;
	for(int j=0;j<src1->deg;j++){
		if(!homFlag&&isHom[src1->id][j] || homFlag&&!isHom[src1->id][j])continue;
		if(k==rnd1){trg1=nodeList[matrixind[src1->id][j]];rnd_loc1=j;found=true;break;}
		k++; 	
	}if(!found)my_exit("Error on shuffle\n");
	
	rnd2=(int)(my_drand48()*(double)deg2);
	found=false;k=0;
	for(int j=0;j<src2->deg;j++){
		if(!homFlag&&isHom[src2->id][j] || homFlag&&!isHom[src2->id][j])continue;
		if(k==rnd2){trg2=nodeList[matrixind[src2->id][j]];rnd_loc2=j;found=true;break;}
		k++; 	
	}if(!found)my_exit("Error on shuffle\n");
	if(trg1==trg2 || src1==trg2 || src2==trg1 ||
	   is_member(trg1->id,matrixind[src2->id],src2->deg) ||
	   is_member(src2->id,matrixind[trg1->id],trg1->deg) ||
	   is_member(trg2->id,matrixind[src1->id],src1->deg) ||
	   is_member(src1->id,matrixind[trg2->id],trg2->deg))continue;
	int inQ=0;
	if(Qmap.find(trg1->id)!=Qmap.end())inQ++;
	if(Qmap.find(trg2->id)!=Qmap.end())inQ++;
	if(Qmap.find(src1->id)!=Qmap.end())inQ++;
	if(Qmap.find(src2->id)!=Qmap.end())inQ++;
	if(inQ>1&&!shuffle_in_Q)continue;
	//printf("selected param:\n");fflush(stdout);
	//printf("trg1=%d, src1=%d trg2=%d src2=%d\n",trg1->id,src1->id,trg2->id,src2->id);fflush(stdout);
	double val1=matrix[src1->id][rnd_loc1];
	double val2=matrix[src2->id][rnd_loc2];
	
	matrixind[src1->id][rnd_loc1]=trg2->id;
	matrix[src1->id][rnd_loc1]=val2;
	int k1=find(src2->id,matrixind_out[trg2->id],trg2->degOut);
	if(k1==-1)my_exit("\nShuffle: integrity\n");
	matrixind_out[trg2->id][k1]=src1->id;
	matrixind[src2->id][rnd_loc2]=trg1->id;
	matrix[src2->id][rnd_loc2]=val1;
	int k2=find(src1->id,matrixind_out[trg1->id],trg1->degOut);
	if(k2==-1)my_exit("Shuffle: integrity\n");
	matrixind_out[trg1->id][k2]=src2->id;
	int k3=find(src1->id,matrixind[trg1->id],trg1->deg);
	int k4=find(src2->id,matrixind[trg2->id],trg2->deg);
	if(k4!=-1 && k3!=-1){
		k1=find(trg1->id,matrixind_out[src1->id],src1->degOut);
		k2=find(trg2->id,matrixind_out[src2->id],src2->degOut);
		double val3=matrix[trg1->id][k3];
		double val4=matrix[trg2->id][k4];
		matrixind[trg2->id][k4]=src1->id;
		matrix[trg2->id][k4]=val3;
		matrixind_out[src1->id][k1]=trg2->id;
		matrixind[trg1->id][k3]=src2->id;
		matrixind_out[src2->id][k2]=trg1->id;
		matrix[trg1->id][k3]=val4;
	}
	cntr++;
  }
  #ifdef VERBOSE
  printf("%d swaps ",cntr);fflush(stdout);
  #endif
}

void shuffleQ(double swap_fact){
  int qsz=Qmap.size();
  int k,rnd1,rnd2,rnd_loc1,rnd_loc2,deg1,deg2,cntr=0;map<int,bool>::iterator ii;
  node *src1,*src2,*trg1,*trg2;
  double num_iter=qsz*swap_fact;
  if(num_iter<nodeList[Qmap.begin()->first]->deg*swap_fact)
  	num_iter=nodeList[Qmap.begin()->first]->deg*swap_fact;
  for(int i=0;i<num_iter;i++){
  	bool homFlag=my_drand48()>0.5;
  	rnd1=(int)(my_drand48()*(double)qsz);
  	k=0;ii=Qmap.begin();while(ii!=Qmap.end()&&k!=rnd1){ii++;k++;}
  	if(k!=rnd1)my_exit("Integrity\n");
	src1=nodeList[ii->first];
	if(homFlag)deg1=src1->deg-src1->degC;else deg1=src1->degC;
	if(deg1==0)continue;
	
	src2=nodeList[(int)(my_drand48()*(double)dim)];
	if(src1==src2 || src2->spec!=src1->spec)continue;
	if(homFlag)deg2=src2->deg-src2->degC;else deg2=src2->degC;
	if(deg2==0)continue;
	
	rnd1=(int)(my_drand48()*(double)deg1);
	bool found=false;int k=0;
	for(int j=0;j<src1->deg;j++){
		if(!homFlag&&isHom[src1->id][j] || homFlag&&!isHom[src1->id][j])continue;
		if(k==rnd1){trg1=nodeList[matrixind[src1->id][j]];rnd_loc1=j;found=true;break;}
		k++; 	
	}if(!found)my_exit("Error on shuffle\n");
	
	rnd2=(int)(my_drand48()*(double)deg2);
	found=false;k=0;
	for(int j=0;j<src2->deg;j++){
		if(!homFlag&&isHom[src2->id][j] || homFlag&&!isHom[src2->id][j])continue;
		if(k==rnd2){trg2=nodeList[matrixind[src2->id][j]];rnd_loc2=j;found=true;break;}
		k++; 	
	}if(!found)my_exit("Error on shuffle\n");
	if(Qmap.find(trg1->id)!=Qmap.end())continue;
	if(Qmap.find(trg2->id)!=Qmap.end())continue;
	if(Qmap.find(src2->id)!=Qmap.end())continue;
	
	if(trg1==trg2 || src1==trg2 || src2==trg1 ||
	   is_member(trg1->id,matrixind[src2->id],src2->deg) ||
	   is_member(src2->id,matrixind[trg1->id],trg1->deg) ||
	   is_member(trg2->id,matrixind[src1->id],src1->deg) ||
	   is_member(src1->id,matrixind[trg2->id],trg2->deg))continue;
	
	double val1=matrix[src1->id][rnd_loc1];
	double val2=matrix[src2->id][rnd_loc2];
	
	matrixind[src1->id][rnd_loc1]=trg2->id;
	matrix[src1->id][rnd_loc1]=val2;
	
	int k1=find(src2->id,matrixind_out[trg2->id],trg2->degOut);
	if(k1==-1){
		printf("%d %d %d\n",i,src1->id,trg1->id);
		my_exit("\nShuffleQ: integrity\n");
	}
	matrixind_out[trg2->id][k1]=src1->id;
	
	matrixind[src2->id][rnd_loc2]=trg1->id;
	matrix[src2->id][rnd_loc2]=val1;
	
	int k2=find(src1->id,matrixind_out[trg1->id],trg1->degOut);
	if(k2==-1){
		printf("%d %d %d\n",i,src2->id,trg2->id);
		my_exit("ShuffleQ: integrity\n");
	}
	matrixind_out[trg1->id][k2]=src2->id;
	
	int k3=find(src1->id,matrixind[trg1->id],trg1->deg);
	int k4=find(src2->id,matrixind[trg2->id],trg2->deg);
	
	if(k4!=-1 && k3!=-1){
		k1=find(trg1->id,matrixind_out[src1->id],src1->degOut);
		k2=find(trg2->id,matrixind_out[src2->id],src2->degOut);
		double val3=matrix[trg1->id][k3];
		double val4=matrix[trg2->id][k4];
		matrixind[trg2->id][k4]=src1->id;
		matrix[trg2->id][k4]=val3;
		//if(homFlag&& val3>15){printf("II: %d <-- %d (trg spec=%d): %g\n",
			//trg2->id,src1->id,trg2->spec,matrix[trg2->id][k4]);}
		matrixind_out[src1->id][k1]=trg2->id;
		
		matrixind[trg1->id][k3]=src2->id;
		matrixind_out[src2->id][k2]=trg1->id;
		matrix[trg1->id][k3]=val4;
	}
	cntr++;
  }
  #ifdef VERBOSE
  printf("%d swaps ",cntr);fflush(stdout);
  #endif
}

#endif /*ANALYZE_OUT_CPP_*/








