#ifndef __MAIN_H
#define __MAIN_H
#include <map>
#include <stdio.h> 
#include <stdlib.h> 
#include <iostream> 
#include <string.h>
#include <math.h> 
#include <sys/types.h>
#include <time.h>
#include <functional>
#include <unistd.h>
#define YRC 1
#define NMD 2
#define MRF 3
#define PPI 0
#define HOM 1
#define BOTH 2
#define TASK_GS 0 
#define TASK_an_OUTPUT 1
#define TASK_Q 2 
#define TASK_EMP 3
#define TASK_CLEAN 4 
#define TASK_RUN_EIG 5
#define TASK_an_OUTPUT_EIG 6
#define TASK_ANALYZE_GS 7
#define MAX_Q 2500
#define MAX_SPEC 50
#define NAME_LEN 256
#define NRM_METHOD 1//0
#define PosTH 2
#define TINY 1e-300
#define MAX_ROC_LIMIT 3000//750
#define YEAST_SC 4932
#define NUM_TH_BIN 100
#define MHRP_PARAM 5
#define NUM_ITER 21
#define VERBOSE_inp 1
#define VERBOSE 1
#define DLI(x) printf("%d\n",x);fflush(stdout);
#define DLS(x) printf("%s\n",x);fflush(stdout);
#define DLF(x) printf("%g\n",x);fflush(stdout);
#define FLS fflush(stdout);

#include "util/util.h"
#include "util/io_util.h"
#include "analyze_out.h"
#include "analyze_q.h"
using namespace std;

extern double sigmaH,sigmaC,rho,alpha,**matrix,**Tmatrix,MAXc,MAXh,tot_ppi;
extern int MAX_LOOP,OPT1,OPT2,IDPROT,dim,**matrixind,**matrixind_out,TASK,REL_TYPE,Qalg_FLAG;
extern bool ONLY_INTERCATING_PROT,**isHom,**isOriginal;
extern map <int,bool>Qmap;//Queries
extern char postfix[256];
extern int dataset;
extern double **PairWiseMat,*G0,**PairWiseMat_help,**W_mul_G0,**aggregateMat,*PRank_vec;
//./rankp1 /nfs/noble2/niryosef/HRP/YRC/Human1 3 1 2
// typedefs
struct ltstr
{
  bool operator()(const char* s1, const char* s2) const;
};

struct ltvoid
{
  bool operator()(void* s1, void* s2) const;
};

class node{
	public:
	int id;	
	int spec;
	int deg;//total deg
	int degC;//only ppi
	int degOut;//total out degree
	map <node *,int,ltvoid> GSH;//if GS, contains all homolog links
	map <node *,int,ltvoid> GSC;//if GS, contains all ppi links
	char *name;
	double roc_score[2];
	node(short spec2,int deg1,char *name1);
};

typedef map <char *,int,ltstr> nlist3;
typedef map <char *,node*,ltstr> Xref;
typedef map <node *,int,ltvoid> nlist;
typedef map <node *,double,ltvoid> nscore;
typedef map <int,double> score_map;
typedef map <int,int> nlist2;
typedef map <int,bool> Present;

extern Xref nodeXref; 
extern node** nodeList;

void ranking(int ver,FILE *fpCVH_score,FILE *fpCVH_loc,FILE *fpCVH_roc,
			FILE *fpCVC_score,FILE *fpCVC_loc,FILE *fpCVC_roc);
void diffuse(double *y,int k,bool PPIflag,double ** Tmat);
void calc_performance(int k,FILE *fp_dtls,FILE *fp_vals,FILE *fp_labs,nlist *GS,
	double *y,int *labels,double *y_unsorted,bool hom);
double tf2_comp(double x,double sigma);
void normalize(double ** Tmat,bool PPIflag);
void normalize_node(double **Tmat,bool PPIflag,int j,int q);
void normalize(double ** Tmat,bool PPIflag,int q,int prev_q);
void clean_grph();
double tf2(double x,double sigma);
void diffuse_all_alg_help(int loopCntr,double *y,double *y_addition, int *prev_k,int k);
void diffuse_all_alg(int *loopCntr,double *y,double *y_addition,double *y_addition2, int *labels, int *prev_k,int k);
void calc_emp_pval(double ***rank1,double ***rank_sig1,double **median_sig1,bool mixInQset);
void emp_pval();
void clean();
void normalizeZSR(double ** Tmatrix);
void ZSR();
void biased_Prank(double *y,int k);
#endif
 
 
