#ifndef IO_UTIL_CPP_
#define IO_UTIL_CPP_
#include "util.h"
#include "io_util.h"


int read_win(char *homeDir, char *task){
	char fname[256];
	int w;map<int,double>sc;
	//sprintf(fname,"%s/ROC/ROC-5.%s.abs.0.win",homeDir,task);
	sprintf(fname,"%s/ROC/ROC-500.%s.abs.1.win",homeDir,task);
	//sprintf(fname,"%s/ROC/ROC-500.%s.rel.1.win",homeDir,task);
	FILE *fp=fopen(fname,"r");int t=0;
	if(fp==NULL)my_exit("No win file\n");
	while(fscanf(fp,"%d ",&w)!=EOF){
		if(sc.find(w)==sc.end())sc[w]=1;
		else sc[w]++;
		t++;
	}
	int k=0;double arr[t];int label[t];
	for(map<int,double>::iterator ii=sc.begin();ii!=sc.end();ii++){
		arr[k]=ii->second;
		label[k++]=ii->first;	
	}
	fclose(fp);
	mergeSort(arr,label,k,true);
	return label[k-1];
}

void clean_dir(char *homeDir, char *task){
	char cmd[256];
	printf("Cleaning %s\n",homeDir);
	if(!strcmp(task,"ppi") && OPT2==1){
		sprintf(cmd,"rm %s/dtls/*.%s.*\n",homeDir,task);
		system(cmd);return;
	} 
	
	if(!strcmp(task,"hom") && OPT2==4){
		sprintf(cmd,"rm %s/dtls/*.%s.*\n",homeDir,task);
		system(cmd);return;
	}
	
	char *abs_rel_arr[]={"abs","rel"};
	int sz_arr[]={5,50,500};
	map<int,double>sc;
	for(int sz=0;sz<3;sz++){
		for(int abs_rel=0;abs_rel<2;abs_rel++){
			for(int mode=0;mode<2;mode++){
				char fname[256];
				int w;//map<int,double>sc;
				sprintf(fname,"%s/ROC/ROC-%d.%s.%s.%d.win",homeDir,sz_arr[sz],
					task,abs_rel_arr[abs_rel],mode);
				FILE *fp=fopen(fname,"r");int t=0;
				if(fp==NULL)continue;
				while(fscanf(fp,"%d ",&w)!=EOF){
					if(sc.find(w)==sc.end())sc[w]=1;
					else sc[w]++;
					t++;
				}fclose(fp);
				/*int k=0;double arr[t];int label[t];
				for(map<int,double>::iterator ii=sc.begin();ii!=sc.end();ii++){
					arr[k]=ii->second;
					label[k++]=ii->first;	
				}
				mergeSort(arr,label,k,true);
				sprintf(cmd,"mv %s/dtls/*.%s.%d %s/\n",homeDir,task,label[k-1],homeDir);
				system(cmd);//printf("%s\n",cmd);
				*/
			}
		}
	}
	if(sc.empty()){my_exit("No ROC files\n");}
	printf("Saving configurations: ");
	for(map<int,double>::iterator ii=sc.begin();ii!=sc.end();ii++){
				sprintf(cmd,"mv %s/dtls/*.%s.%d %s/\n",homeDir,task,ii->first,homeDir);
				printf("%d, ",ii->first);
				system(cmd);//printf("%s\n",cmd);
	}printf("\n");
	if(sc.empty())return;
	sprintf(cmd,"rm %s/dtls/*.%s.*\n",homeDir,task);system(cmd);//printf("%s\n",cmd);
	sprintf(cmd,"mv %s/ranks.* %s/dtls/\n",homeDir,homeDir);system(cmd);//printf("%s\n",cmd);
	sprintf(cmd,"mv %s/vals.* %s/dtls/\n",homeDir,homeDir);system(cmd);//printf("%s\n",cmd);
	sprintf(cmd,"mv %s/label.* %s/dtls/\n",homeDir,homeDir);system(cmd);//printf("%s\n",cmd);
	
}

bool load_config(char * config,char Hflist[MAX_SPEC][NAME_LEN],int *nH,int sH[MAX_SPEC][2],
					char Cflist[MAX_SPEC][NAME_LEN],int *nC,
					int sC[MAX_SPEC][2],char *qfname,char *GSCfile,char *GSHfile){
		FILE *fp=fopen(config,"r");
		if(fp==NULL){printf("Could not open: %s\n",config);exit(0);}
		int s1,s2,cntr=0,cntr1=0;char tmp[NAME_LEN],name1[NAME_LEN];
		fscanf(fp,"%s\n",tmp);
		if(strcmp(tmp,">Int")!=0){printf("wrong file format\n");exit(-1);}
		while(fscanf(fp,"%d %s\n",&s1,name1)!=EOF){
			if(!strcmp(name1,">Hom"))break;
			sC[cntr][0]=s1;sC[cntr][1]=s1;
			strcpy(Cflist[cntr++],name1);
		}
		bool qflag=false;
		while(fscanf(fp,"%d %d %s\n",&s1,&s2,name1)!=EOF){
			if(!strcmp(name1,">query")){qflag=true;break;}
			if(!strcmp(name1,">trng")){break;}
			sH[cntr1][0]=s1;sH[cntr1][1]=s2;
			strcpy(Hflist[cntr1++],name1);
		}
		if(qflag)fscanf(fp,"%s\n",qfname);
		else{//gold standard
			fscanf(fp,"%s\n",tmp);
			if(strcmp(tmp,">Int")!=0){printf("wrong file format\n");exit(-1);}
			while(fscanf(fp,"%s\n",name1)!=EOF){
				if(!strcmp(name1,">Hom"))break;
				strcpy(GSCfile,name1);
			}
			while(fscanf(fp,"%s\n",name1)!=EOF){
				strcpy(GSHfile,name1);
			}
		}
		fclose(fp);
		(*nH)=cntr1;(*nC)=cntr;
		return qflag;
}

 
void load_query(char *fname){ 
	  char name[NAME_LEN];Xref::iterator ii;
	  #ifdef VERBOSE 
	  printf("load_query: open file %s\n",fname);fflush(stdout);
	  #endif
	  FILE *fquery=fopen(fname,"r");  
	  if (fquery==NULL) {printf("ERROR: File %s not found!\n",fname); exit(0);} 
	  while(fscanf(fquery,"%s\n",name)!=EOF){
		ii=nodeXref.find(name);
		if(ii==nodeXref.end()){
			//printf("Warning, query protein not in network:%s\n",name);
		}
		else
	  		Qmap[ii->second->id]=true;
	  }
	  fclose(fquery);
	  #ifdef VERBOSE_inp
	  printf("Number of queries: %d\n",Qmap.size());fflush(stdout);
	  #endif
} 


void load_query2(char *fname,bool gs){ 
	  char name1[NAME_LEN],name2[NAME_LEN];Xref::iterator ii1,ii2;
	  int val;
	  #ifdef VERBOSE 
	  printf("load_query: open file %s\n",fname);fflush(stdout);
	  #endif
	  FILE *fquery=fopen(fname,"r");  
	  if (fquery==NULL) {printf("ERROR: File %s not found!\n",fname); exit(0);} 
	  while(fscanf(fquery,"%s %s %d\n",name1,name2,&val)!=EOF){
	    if(!gs&&val!=2 || gs&&val==2)continue;
		ii1=nodeXref.find(name1);ii2=nodeXref.find(name2);
		if(ii1==nodeXref.end() || ii2==nodeXref.end() ){}
			//printf("Warning, query protein not in network:%s-%s [%d]\n",name1,name2,val);
		else{
	  		Qmap[ii1->second->id]=true;
			ii1->second->GSH[ii2->second]=0;//not using the lable (forbidden!)
		}
	  }
	  fclose(fquery);
	  #ifdef VERBOSE_inp
	  printf("(2)Number of queries: %d\n",Qmap.size());fflush(stdout);
	  #endif
} 


int * load_best_configs(char *prefix){
	char outcv_cls[256],name1[256];int *best_cnfg=new int[dim];
	Xref::iterator ii1;
	for(int i=0;i<dim;i++)best_cnfg[i]=-1;
	sprintf(outcv_cls,"%s/ROC/ROC-500.hom.abs.1.cv_cls",postfix);
	//sprintf(outcv_cls,"%s/ROC/ROC-5.hom.abs.0.cv_cls",postfix);
	FILE *fpcls=fopen(outcv_cls,"r");int val,cntr=0;
	while(fscanf(fpcls,"%s %d\n",name1,&val)!=EOF){
	    ii1=nodeXref.find(name1);
		if(ii1==nodeXref.end()){
			printf("Error: GS protein not in network:%s\n",name1);exit(-1);
		}
		else best_cnfg[ii1->second->id]=val;
		cntr++;
	}
	fclose(fpcls);
	//#ifdef VERBOSE_inp
	printf("Loaded %d configs from %s\n",cntr,outcv_cls);
	//#endif
	return best_cnfg;
}
int loadGS(char *fname,bool HomFlag){
	  //Determine degrees and mk nodeL
	  //printf("LoadGS: %s\n",fname);fflush(stdout);
	  int val;
	  char name1[NAME_LEN],name2[NAME_LEN];
	  map<int,bool>newQ;
	  Xref::iterator ii1,ii2;int cntr=0;
	  FILE *fp=fopen(fname,"r");if(fp==NULL)my_exit("loadGS:could not open file\n");
	  while(fscanf(fp,"%s\t%s\t%d\n",name1,name2,&val)!=EOF){//Qmap.size()<100 && 
	  		if(dataset==NMD || dataset==YRC)val=1;
	  		if(val==2)continue;if(val==0)val=2;//negatives on MRF
	  		if(!strcmp(name1,name2))continue;
	  		ii1=nodeXref.find(name1);
			ii2=nodeXref.find(name2);
			if(ii1==nodeXref.end() || ii2==nodeXref.end()){
				//printf("Could dnot find GS %s\t%s\t%d\n",name1,name2,val);
				continue;
			}
		  	if(!HomFlag){//PPI  -- filtering task 
		  		bool inData=false;
		  		int id1=ii1->second->id,id2=ii2->second->id;
		  		for(int k=0;k<ii1->second->deg && !inData;k++)inData=matrixind[id1][k]==id2;
				if(!inData)continue;
				ii1->second->GSC[ii2->second]=val;
		  		Qmap[ii1->second->id]=true;
		  		newQ[ii1->second->id]=true;
		  	}
		  	else{
		  		ii1->second->GSH[ii2->second]=val;
		  		Qmap[ii1->second->id]=true;
		  		newQ[ii1->second->id]=true;
		  	}
	  }
	  #ifdef VERBOSE_inp
	  printf("%d queries for task %d\n", newQ.size(),HomFlag);
	  #endif
	  fclose(fp);
	  //For homologies - mark best match not in HomoloGene
	  if(HomFlag && dataset!=MRF){
		  for(map<int,bool>::iterator kk=Qmap.begin();kk!=Qmap.end();kk++){
		  		node *nd=nodeList[kk->first];
		  		if(nd->GSH.empty())continue;
		  		double mn=2;
		  		int id=nd->id;int deg=nd->deg; 
		  		for(int i=0;i<deg;i++){
		  			if(isHom[id][i]&&nd->GSH.find(nodeList[matrixind[id][i]])==nd->GSH.end()){
		  				if(mn>matrix[id][i]){mn=matrix[id][i];}
		  			}
		  		}
		  		if(mn!=2){
		  			for(int i=0;i<deg;i++){
		  				if(isHom[id][i]&&nd->GSH.find(nodeList[matrixind[id][i]])==nd->GSH.end()){
		  					if(mn>=matrix[id][i]){
		  						nd->GSH[nodeList[matrixind[id][i]]]=2;
		  					}
		  				}
		  			}	
		  		}
		  }
	  }
	  return cntr;
} 


 
void load1(char *fname,bool HomFlag,int *spec1){
	//Determine degrees and mk nodeL
	  #ifdef VERBOSE
	  printf("Load1: %s\n",fname);fflush(stdout);
	  #endif
	  map<int, bool>read_e;
	  double val;char name1[NAME_LEN],name2[NAME_LEN],*tmp;
	  Xref::iterator ii,ii2;node *tmp2;
	  FILE *fp=fopen(fname,"r");if(fp==NULL){my_exit("Could not open file\n");}
	  while(fscanf(fp,"%s\t%s\t%lf\n",name1,name2,&val)!=EOF){ 
	  		if(!strcmp(name1,name2))continue; 		
	  		ii=nodeXref.find(name1);
	  		ii2=nodeXref.find(name2);
	  		if(ONLY_INTERCATING_PROT){
	  			if(HomFlag && (ii==nodeXref.end() || ii2==nodeXref.end())){
	  				//printf("%s %s\n",name1,name2);
	  				continue;}
	  		}
	  		if (ii!=nodeXref.end() && ii2!=nodeXref.end() &&
	  			(read_e.find(ii->second->id*100000+ii2->second->id)!=read_e.end() ||
	  			read_e.find(ii2->second->id*100000+ii->second->id)!=read_e.end()))continue;
		  	
			if(ii==nodeXref.end()){
		  		tmp=new char[strlen(name1)+2];sprintf(tmp,name1);
		  		tmp2=new node(spec1[0],1,tmp);
		  		nodeXref[tmp]=tmp2;
		  		ii=nodeXref.find(name1);
		  	}else ii->second->deg++;
		  	if(!HomFlag)ii->second->degC++;  	
		  	
		  	if(ii2==nodeXref.end()){
		  		tmp=new char[strlen(name2)+2];sprintf(tmp,name2);
		  		if(!HomFlag)//homology graph is directed
		  			tmp2=new node(spec1[0],1,tmp);
				else
		  			tmp2=new node(spec1[1],0,tmp);
		  		nodeXref[tmp]=tmp2;
		  		ii2=nodeXref.find(name2);
		   	}else if(!HomFlag)ii2->second->deg++;
		  	if(!HomFlag)ii2->second->degC++;
	
		  	ii2->second->degOut++;
		  	if(!HomFlag)ii->second->degOut++;
		  	
		  	read_e[ii->second->id*100000+ii2->second->id]=true;
		  	
	  }fclose(fp);	
} 

void load2(char *fname,bool HomFlag,int *cntr,int *cntrOut){
	map<int, bool>read_e;
	Xref::iterator ii,ii2;
	double val;char name1[NAME_LEN],name2[NAME_LEN];
	int id1,id2,deg1,deg2;
	FILE *fp=fopen(fname,"r");
	//printf("Reading file %s (%d)\n",fname,HomFlag);fflush(stdout);
	while(fscanf(fp,"%s\t%s\t%lf\n",name1,name2,&val)!=EOF){
			if(!strcmp(name1,name2))continue;
			if(dataset!=YRC && !HomFlag){val=1.-val;}//in YRC it's HG scores (low is good), in the rest its confidence (high is good)
			if(OPT2==11 && !HomFlag){val=1.-val;}//for prank high is good
			if(val<TINY){val=TINY;}
			ii=nodeXref.find(name1);
	  		ii2=nodeXref.find(name2);
	  		if(ONLY_INTERCATING_PROT){//assuming load1 
	  			if(HomFlag && (ii==nodeXref.end() || ii2==nodeXref.end())){
	  				continue;
	  			}
	  		}
	  		if(ii==nodeXref.end() || ii2==nodeXref.end() )my_exit("error\n");
			if (read_e.find(ii->second->id*100000+ii2->second->id)!=read_e.end() ||
	  			read_e.find(ii2->second->id*100000+ii->second->id)!=read_e.end()){
	  			node *nd=ii->second;node *nd2=ii2->second;
	  			//Change E-value if lower
	  			if(HomFlag){
	  				for(int kk=0;kk<cntr[nd->id];kk++)
		  				if(matrixind[nd->id][kk]==nd2->id && matrix[nd->id][kk]>val)
	  					matrix[nd->id][kk]=val;
	  			}
	  			continue;
	  		}
	  		
	  		read_e[ii->second->id*100000+ii2->second->id]=true;
			if(HomFlag && val>MAXh)MAXh=val;if(!HomFlag && val>MAXc)MAXc=val;
			id1=nodeXref[name1]->id;
		  	deg1=nodeXref[name1]->deg;
		  	id2=nodeXref[name2]->id;
		  	deg2=nodeXref[name2]->deg;
		  	if(cntr[id1]==0){
		  		matrix[id1]= new double[deg1]; 
		  		Tmatrix[id1]= new double[deg1];
		  		matrixind[id1]= new int[deg1];
		    	isHom[id1]= new bool[deg1];
		  	}
		  	isHom[id1][cntr[id1]]=HomFlag;
		  	matrixind[id1][cntr[id1]]=id2;
		  	matrix[id1][cntr[id1]++]=val;
		  	if(cntrOut[id2]==0)matrixind_out[id2]=new int[nodeList[id2]->degOut];
		  	matrixind_out[id2][cntrOut[id2]++]=id1;
		  	
			if(HomFlag)continue;
		  	if(cntr[id2]==0){
		  		matrix[id2]= new double[deg2];
		  		Tmatrix[id2]= new double[deg2];
		  		matrixind[id2]= new int[deg2];
		    	isHom[id2]= new bool[deg2];
		  	}	  	
		  	isHom[id2][cntr[id2]]=HomFlag;
		  	matrixind[id2][cntr[id2]]=id1;
		  	matrix[id2][cntr[id2]++]=val;
		  	if(cntrOut[id1]==0)matrixind_out[id1]=new int[nodeList[id1]->degOut];
		  	matrixind_out[id1][cntrOut[id1]++]=id2;
		  	tot_ppi+=1-val; //must be a PPI entry (!HomFlag)
		  	
	  }fclose(fp); 	
	  
}

void load_matrix(char Cfname[MAX_SPEC][NAME_LEN],int specsC[MAX_SPEC][2],int nC,
	char Hfname[MAX_SPEC][NAME_LEN],int specsH[MAX_SPEC][2],int nH,bool read_ppi)    
{ 
	  if(ONLY_INTERCATING_PROT)read_ppi=true;
	  if(read_ppi){
	  	int tmp=0;
	  	for(int i=0;i<nC;i++){
		  	load1(Cfname[i],false,specsC[i]);
		  	#ifdef VERBOSE_inp
		  	printf("%d interacting proteins read for speacies %d\n",nodeXref.size()-tmp,specsC[i][0]);
		  	#endif
		  	tmp=nodeXref.size();
	  	}
	  }
	  for(int i=0;i<nH;i++)
	  	load1(Hfname[i],true,specsH[i]);
	  dim= nodeXref.size();
	  #ifdef VERBOSE
	  printf("Proteins in database: %d\n",dim);
	  #endif
	  matrix=new double*[dim+2];
	  Tmatrix=new double*[dim+2];
	  matrixind=new int*[dim+2];
	  matrixind_out=new int*[dim+2];
	  isHom=new bool*[dim+2];
	  nodeList=new node*[dim+2];
	  int *cntr=new int[dim],*cntrOut=new int[dim];
	  for(int i=0;i<dim;i++){cntr[i]=0;cntrOut[i]=0;}
	  for(Xref::iterator ii=nodeXref.begin();ii!=nodeXref.end();ii++)
	  		nodeList[ii->second->id]=ii->second;
	  if(read_ppi)for(int i=0;i<nC;i++)load2(Cfname[i],false,cntr,cntrOut);
	  for(int i=0;i<nH;i++)load2(Hfname[i],true,cntr,cntrOut);
	  delete[]cntr; delete[]cntrOut;
	  /*FILE *fp=fopen("deg","w");
	  for(int i=0;i<dim;i++)fprintf(fp,"%d %d\n",nodeList[i]->degC,nodeList[i]->deg-nodeList[i]->degC);
	  fclose(fp);exit(0);*/
} 


 void print_gs_list(FILE *fpC,FILE *fpH){
 	for(map<int,bool>::iterator kk=Qmap.begin();kk!=Qmap.end();kk++) 
	  {
		  	int k=kk->first;	
		  	for(nlist::iterator ii=nodeList[k]->GSH.begin();ii!=nodeList[k]->GSH.end();ii++)
	    		fprintf(fpH,"%s %s %d\n",nodeList[k]->name,ii->first->name,ii->second);
	    	for(nlist::iterator ii=nodeList[k]->GSC.begin();ii!=nodeList[k]->GSC.end();ii++)
	    		fprintf(fpC,"%s %s %d\n",nodeList[k]->name,ii->first->name,ii->second);
	  }
 }
	
	
void write_config(){
  double GRID[]={-5,-2,0,2,5};int GRID_SZ=5;
  double ALPHA_GRID[]={0.3,0.95};//,1.6};
  int ALPHA_GRID_SZ=2;
  char fname[NAME_LEN];
  int strt=0;if(OPT2==1)strt=GRID_SZ-1;
  int ver=0;
  sprintf(fname,"%s/configs",postfix);
  FILE *fp=fopen(fname,"w");
  	for(int i=0;i<GRID_SZ;i++){ 
  	if(GRID[i]<0)continue;
  	sigmaH=pow(10,GRID[i]); //sigma starts from zero
  	for(int j=strt;j<GRID_SZ;j++){
  		if(GRID[j]<0)continue; //sigma starts from zero
  		sigmaC=pow(10,GRID[j]);
  		for(int k=strt;k<GRID_SZ;k++){
  			rho=pow(5,GRID[k]);
  			for(int l=0;l<ALPHA_GRID_SZ;l++){
  				alpha=ALPHA_GRID[l];
  				if(OPT2==0 || OPT2==6 || OPT2==7)alpha=0;      
  				fprintf(fp,"%d %g %g %g %g\n",ver, sigmaH,sigmaC,rho,alpha);
  				if(OPT2==0 || OPT2==6 || OPT2==7){fclose(fp);exit(0);}
  				ver++;
  			}
  		}
  	}
  }
  fclose(fp);
  exit(0);	
}
#endif /*IO_UTIL_CPP_*/
